%Johann Pototschnig, Forttgeschrittene Applikationssoftware, WS 2010/2011
%Software zur Berechnung eines Thermodynamischer Kreisprozesses

%Die vier Punkte des Kreizprozesses sind gegeben durch:
% 1.Punkt: data.T1, data.p1, data.V1
% 2.Punkt: data.T2, ....
%Paramter:
%Polytropenexponent: data.gam; Waermekapazitaet data.cp, ... 
%Entscheidungsparameter
% Prozesstyp: data.prozess1typ, ...
%Einstellungsvariable: data.prozess1_var, ...

%%%%%%%%%%%%%%%%%%%%%%%%Initialisierung
close all;
data=struct();
data.R=8.314;
data.points=30; %Stuetzstellen der Graphik
data.umgebung=5000; %Suchbereich fuer vierten Punkt

%%%%%%%%%%%%%%%%%%%Eingabe des Startpunkts
data.eingabe_startpunkt=figure;
set(data.eingabe_startpunkt,'Name','Startpunkteingabe');
data.startpunkt_ax=axes('position',[0,0,1,1]);
set(data.startpunkt_ax,'visible','off');

schrift=['Geben Sie bitte die Parameter';'       des Startpunkts ein:  '];
data.startpunkt_ueberschrift=text(0.15,0.9,schrift,'FontSize',20);

data.startpunkt_temp=text(0.1,0.75,'Temperatur [K]:','FontSize',20 );
data.startpunkt_temp_ed=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.45,0.70,0.2,0.1],...
                    'Callback','data=teststart(data,1);'); 
set(data.startpunkt_temp_ed,'string','290','fontsize',20);

data.startpunkt_druck=text(0.1,0.6,'Druck [Pa]:','FontSize',20 ); 
data.startpunkt_druck_ed=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.4,0.55,0.2,0.1],...
                    'Callback','data=teststart(data,2);');
set(data.startpunkt_druck_ed,'string','100000','FontSize',20);

data.startpunkt_volumen=text(0.1,0.45,'Volumen [m^3]:','FontSize',20 ); 
data.startpunkt_volumen_ed=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.45,0.4,0.2,0.1],...
                    'Callback','data=teststart(data,3);'); 
set(data.startpunkt_volumen_ed,'string','10','FontSize',20);



data.startpunkt_kappa=text(0.1,0.30,'Polytropenexponent: ','FontSize',20 );  
data.startpunkt_kappa_ed=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.55,0.25,0.2,0.1],...
                    'Callback','data=teststart(data,4);'); 
set(data.startpunkt_kappa_ed,'string','1.25','FontSize',20);

data.startpunkt_cv=text(0.1,0.18,'Adiabatisch:','FontSize',20 );   
data.startpunkt_gam=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.35,0.15,0.23,0.07],...
                   'string','gamma',...
                   'Callback','data=adiab_checkbox(data,1);','FontSize',20); 
data.startpunkt_cv=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.58,0.15,0.15,0.07],...
                   'string','c_V',...
                   'Callback','data=adiab_checkbox(data,2);','FontSize',20); 
data.startpunkt_cp=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.73,0.15,0.15,0.07],...
                   'string','c_p',...
                   'Callback','data=adiab_checkbox(data,3);','FontSize',20); 
data.startpunkt_adiab_einheit=text(0.5,0.05,'','FontSize',20 );   

set(data.startpunkt_gam,'value',1);
data.adiabtisch_wahl=1;
               
data.startpunkt_adiab=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.3,0.01,0.15,0.1],...
                    'Callback','data=teststart(data,5);'); 
set(data.startpunkt_adiab,'string','1.4','FontSize',20);

data.startpunkt_but=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.7,0.0,0.3,0.1], ...
                   'String','Akzeptieren',...
                   'Callback','data=startcallback(data);','FontSize',20);
               
               
%%%%%%%%%%%%%%%% Angabe der Prozesse
data.prozesse=figure;
set(data.prozesse,'Name','Prozesse');
set(data.prozesse,'visible','off');
data.prozesse_ax=axes('position',[0,0,1,1]);
set(data.prozesse_ax,'visible','off');
schrift=['Geben Sie bitte die Prozessschritte an:'];
data.prozesse_ueberschrift=text(0.1,0.95,schrift,'FontSize',20);
set(data.prozesse,'CloseRequestFcn','data=close_prozesse_callback(data);');


%1.Prozessschritt
data.prozess1_text=text(0.05,0.85,'1. Schritt:','FontSize',15);
data.prozess1_isotherm=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.77,0.2,0.05],...
                   'string','isotherm',...
                   'Callback','data=prozess_checkbox(data,1,1);'); 
set(data.prozess1_isotherm,'value',1);    
data.prozess1typ=1;
data.prozess1_isobar=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.72,0.2,0.05],...
                   'string','isobar',...
                   'Callback','data=prozess_checkbox(data,1,2);');
data.prozess1_isochor=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.67,0.2,0.05],...
                   'string','isochor',...
                   'Callback','data=prozess_checkbox(data,1,3);'); 
data.prozess1_adiabatisch=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.62,0.2,0.05],...
                   'string','adiabatisch',...
                   'Callback','data=prozess_checkbox(data,1,4);'); 
data.prozess1_polytrop=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.57,0.2,0.05],...
                   'string','polytrop',...
                   'Callback','data=prozess_checkbox(data,1,5);'); 

%2.Prozessschritt
data.prozess2_text=text(0.55,0.85,'2. Schritt:','FontSize',15);
data.prozess2_isotherm=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.77,0.2,0.05],...
                   'string','isotherm',...
                   'Callback','data=prozess_checkbox(data,2,1);'); 
data.prozess2_isobar=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.72,0.2,0.05],...
                   'string','isobar',...
                   'Callback','data=prozess_checkbox(data,2,2);');
data.prozess2_isochor=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.67,0.2,0.05],...
                   'string','isochor',...
                   'Callback','data=prozess_checkbox(data,2,3);'); 
data.prozess2_adiabatisch=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.62,0.2,0.05],...
                   'string','adiabatisch',...
                   'Callback','data=prozess_checkbox(data,2,4);'); 
set(data.prozess2_adiabatisch,'value',1);    
data.prozess2typ=4;
data.prozess2_polytrop=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.57,0.2,0.05],...
                   'string','polytrop',...
                   'Callback','data=prozess_checkbox(data,2,5);'); 
               
%3.Prozessschritt
data.prozess3_text=text(0.05,0.45,'3. Schritt:','FontSize',15);
data.prozess3_isotherm=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.38,0.2,0.05],...
                   'string','isotherm',...
                   'Callback','data=prozess_checkbox(data,3,1);'); 
set(data.prozess3_isotherm,'value',1);    
data.prozess3typ=1;
data.prozess3_isobar=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.33,0.2,0.05],...
                   'string','isobar',...
                   'Callback','data=prozess_checkbox(data,3,2);');
data.prozess3_isochor=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.28,0.2,0.05],...
                   'string','isochor',...
                   'Callback','data=prozess_checkbox(data,3,3);'); 
data.prozess3_adiabatisch=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.23,0.2,0.05],...
                   'string','adiabatisch',...
                   'Callback','data=prozess_checkbox(data,3,4);'); 
data.prozess3_polytrop=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.01,0.18,0.2,0.05],...
                   'string','polytrop',...
                   'Callback','data=prozess_checkbox(data,3,5);'); 

%4.Prozessschritt
data.prozess4_text=text(0.55,0.45,'4. Schritt:','FontSize',15);
data.prozess4_isotherm=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.38,0.2,0.05],...
                   'string','isotherm',...
                   'Callback','data=prozess_checkbox(data,4,1);'); 
data.prozess4_isobar=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.33,0.2,0.05],...
                   'string','isobar',...
                   'Callback','data=prozess_checkbox(data,4,2);');
data.prozess4_isochor=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.28,0.2,0.05],...
                   'string','isochor',...
                   'Callback','data=prozess_checkbox(data,4,3);'); 
data.prozess4_adiabatisch=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.23,0.2,0.05],...
                   'string','adiabatisch',...
                   'Callback','data=prozess_checkbox(data,4,4);'); 
set(data.prozess4_adiabatisch,'value',1);    
data.prozess4typ=4;
set(data.prozess4_isotherm,'visible','off');
data.prozess4_polytrop=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.50,0.18,0.2,0.05],...
                   'string','polytrop',...
                   'Callback','data=prozess_checkbox(data,4,5);'); 
               
%Prozesse fixieren, Typ angegeben

data.prozess_but=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.01,0.01,0.25,0.1],...
                   'String','Typ fixieren',...
                   'Callback','data=prozess_typ(data);','FontSize',15);


               
%%%%%%%%%%%%%%%%%%%%%%Angabe der Varaibalen
% checkboxes fuer T, p, v

data.prozess1_T_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.21,0.725,0.25,0.075],...
                   'string','Temperatur',...
                   'Callback','data=var_checkbox(data,1,1);',...
                   'fontsize',15,'visible','off');
data.prozess1_V_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.21,0.65,0.25,0.075],...
                   'string','Volumen',...
                   'Callback','data=var_checkbox(data,1,2);',...
                   'fontsize',15,'visible','off');
data.prozess1_p_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.21,0.575,0.25,0.075],...
                   'string','Druck',...
                   'Callback','data=var_checkbox(data,1,3);',...
                   'fontsize',15,'visible','off'); 
               
               
data.prozess2_T_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.7,0.725,0.25,0.075],...
                   'string','Temperatur',...
                   'Callback','data=var_checkbox(data,2,1);',...
                   'fontsize',15,'visible','off');
data.prozess2_V_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.7,0.65,0.25,0.075],...
                   'string','Volumen',...
                   'Callback','data=var_checkbox(data,2,2);',...
                   'fontsize',15,'visible','off');
 data.prozess2_p_checkb=uicontrol('STYLE','checkbox', ....
                   'units','normalized',....
                   'Position',[0.7,0.575,0.25,0.075],...
                   'string','Druck',...
                   'Callback','data=var_checkbox(data,2,3);',...
                   'fontsize',15,'visible','off');
               

%Variablen fixieren, Werte abfragen
data.variablen_but=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.35,0.01,0.25,0.1],...
                   'String','Var. fixieren','visible','off',...
                   'Callback','data=prozess_var(data);','FontSize',15);

%%%%%%%%%%%%%%%%%%%%%%% Angabe der Endwerte
%Eingabefelder fuer Endpunkte

data.prozess1_ende=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.1,0.52,0.15,0.05],...
                    'Callback','data=var_testcallback(data,1);',...
                    'visible','off','string','5'); 
data.prozess1_ende_text=text(0.26,0.54,'');

data.prozess2_ende=uicontrol('STYLE','edit', ....
                   'units','normalized',....
                   'Position',[0.6,0.52,0.15,0.05],...
                    'Callback','data=var_testcallback(data,2);',...
                    'visible','off','string','1'); 
data.prozess2_ende_text=text(0.76,0.54,'');
                

%%%%%%%%%%%%%%%%%%%%%%%%%%%Kreisprozess berechnen

data.Kreisprozess_button=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.74,0.01,0.25,0.1],...
                   'String','Berechnen','visible','off',...
                   'Callback','data=Kreisprozess(data);','FontSize',15);
               
               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Darstellung

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% pV - Diagramm
data.pV_diagramm=figure;
set(data.pV_diagramm,'Name','pV-Diagramm');
set(data.pV_diagramm,'visible','off');
data.pV_ax=axes('position',[0.05,0.28,0.90,0.65]);
set(data.pV_diagramm,'CloseRequestFcn','data=close_pV_callback(data);');


data.pV_plot1=plot(1:10,1:10,'r');
set(data.pV_plot1,'Displayname','1. Schritt');
hold on
data.pV_plot2=plot(1:10,1:10,'b');
set(data.pV_plot2,'Displayname','2. Schritt');
data.pV_plot3=plot(1:10,1:10,'g');
set(data.pV_plot3,'Displayname','3. Schritt');
data.pV_plot4=plot(1:10,1:10,'k');
set(data.pV_plot4,'Displayname','4. Schritt');
data.pV_plot5=plot(1:10,1:10,'y');
set(data.pV_plot5,'Displayname','5. Schritt','visible','off');


data.pV_legend=legend('show');
set(data.pV_legend,'location','best');
Zeilen=['p=';'V=';'T='];

data.boxweite_pV=530;
data.pV_tabelle=uitable('units','normalized',...
    'position',[0.01,0.01,0.99,0.2], ...
    'data', zeros(3,5),...
    'Rowname',Zeilen);
               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   TS - 3Diagramm
data.TS_diagramm=figure;
set(data.TS_diagramm,'Name','TS-Diagramm');
set(data.TS_diagramm,'visible','off');
data.TS_ax=axes('position',[0.05,0.32,0.90,0.65]);
set(data.TS_diagramm,'CloseRequestFcn','data=close_TS_callback(data);');

data.TS_plot1=plot(1:10,1:10,'r');
set(data.TS_plot1,'Displayname','1. Schritt');
hold on
data.TS_plot2=plot(1:10,1:10,'b');
set(data.TS_plot2,'Displayname','2. Schritt');
data.TS_plot3=plot(1:10,1:10,'g');
set(data.TS_plot3,'Displayname','3. Schritt');
data.TS_plot4=plot(1:10,1:10,'k');
set(data.TS_plot4,'Displayname','4. Schritt');

data.TS_plot5=plot(1:10,1:10,'y');
set(data.TS_plot5,'Displayname','5. Schritt','visible','off');
data.TS_legend=legend('show');
set(data.TS_legend,'location','best');

Zeilen=['U';'W';'Q';'S'];
data.boxweite_TS=540;
data.TS_tabelle=uitable('units','normalized',...
    'position',[0,0,1,0.25], ...
    'data', zeros(4,5),...
    'Rowname',Zeilen);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 3D -Plot
data.D3_diagramm=figure;
set(data.D3_diagramm,'Name','3D-Diagramm');
set(data.D3_diagramm,'visible','off');
data.D3_ax=axes('position',[0.05,0.2,0.90,0.75]);
set(data.D3_diagramm,'CloseRequestFcn','data=close_D3_callback(data);');


data.D3_plot1=plot3(1:10,1:10,1:10,'r');
set(data.D3_plot1,'Displayname','1. Schritt');
hold on
data.D3_plot2=plot3(1:10,1:10,1:10,'b');
set(data.D3_plot2,'Displayname','2. Schritt');
data.D3_plot3=plot3(1:10,1:10,1:10,'g');
set(data.D3_plot3,'Displayname','3. Schritt');
data.D3_plot4=plot3(1:10,1:10,1:10,'k');
set(data.D3_plot4,'Displayname','4. Schritt');

data.D3_plot5=plot(1:10,1:10,'y');
set(data.D3_plot5,'Displayname','5.Schritt','visible','off');

data.D3_legend=legend('show');
set(data.D3_legend,'location','best');
grid on
xlabel('p');
ylabel('V');
zlabel('T');

data.boxweite_D3=540;
data.D3_tabelle=uitable('units','normalized',...
    'position',[0,0,1,0.1], ...
    'data', zeros(1,3),...
    'Rowname','');
Spalten=['   Arbeit   ';'   Waerme   ';'Wirkungsgrad'];
set(data.D3_tabelle,'columnname',Spalten);





                
